bind Text <Shift-3>   {text-start-move-drag %W %x %y}
bind Text <Control-3> {text-start-copy-drag %W %x %y}
bind Text <3>         {text-start-plain-drag %W}

proc text-start-plain-drag {w} {
    if ![dragdrop source $w issource] return
    global dragdropgenerator textdragdrop
    lappend dragdropgenerator($w) STRING
    if [llength [$w tag ranges sel]] {
	set textdragdrop(data) [$w get sel.first sel.last]
    } else {
	set textdragdrop(data) [$w get 1.0 end]
    }
}
proc text-start-copy-drag {w x y} {
    if ![dragdrop source $w issource] return
    if {[$w cget -state] == "disabled"} {
	text-start-plain-drag $w
    } else {
	global dragdropgenerator textdragdrop
	if [lsearch -exact [$w tag names current] sel]>=0 {
	    lappend dragdropgenerator($w) TEXT-INTERNAL-COPY
	    set textdragdrop(data) [$w get sel.first sel.last]
	    set textdragdrop(first) [$w index sel.first]
	    set textdragdrop(last) [$w index sel.last]
	    set textdragdrop(source) $w
	}
    }
}
proc text-start-move-drag {w x y} {
    if ![dragdrop source $w issource] return
    if {[$w cget -state] == "disabled"} {
	text-start-plain-drag $w
    } else {
	global dragdropgenerator textdragdrop
	if [lsearch -exact [$w tag names current] sel]>=0 {
	    lappend dragdropgenerator($w) TEXT-INTERNAL-MOVE
	    set textdragdrop(data) [$w get sel.first sel.last]
	    set textdragdrop(first) [$w index sel.first]
	    set textdragdrop(last) [$w index sel.last]
	    set textdragdrop(source) $w
	}
    }
}
proc text-can-drop {w x y i t} {
    global textdragdrop
    if {$x == "" || $y == ""} {
	catch {
	    $textdragdrop(can-drop) $w $x $y $i $t
	}
    }
    foreach ty $t {
	switch $ty {
	    STRING {
		if {[$w cget -state] != "disabled"} {
		    return 1
		}
	    }
	    TEXT-INTERNAL-MOVE -
	    TEXT-INTERNAL-COPY {
		if {("$i" != [tk appname] || \
			"$w" != $textdragdrop(source) || \
			[$w compare @$x,$y < $textdragdrop(first)] || \
			[$w compare @$x,$y > $textdragdrop(last)]) &&\
			[$w cget -state] != "disabled"} {
		    return 1
		}
	    }
	    default {
		set r {}
		catch {
		    set cmd [concat $textdragdrop(can-drop) \
			    [list $w $x $y $i [list $ty]]]
		    set r [eval $cmd]
		}
		if [llength $r] {
		    return $r
		}
	    }
	}
    }
    return 0
}
proc text-drop-string {w x y i t d} {
    $w insert @$x,$y $d
}
proc text-drop-copy {w x y i t d} {
    global textdragdrop
    send -- $i [$textdragdrop(source) tag remove sel 1.0 end]
    $w insert @$x,$y [send -- $i [list set textdragdrop(data)]] sel
    set textdragdrop(data) {}
    set textdragdrop(first) {}
    set textdragdrop(last) {}
    set textdragdrop(source) {}
}
proc text-drop-move {w x y i t d} {
    global textdragdrop
    set d [send -- $i [list set textdragdrop(data)]]
    set f [send -- $i [list set textdragdrop(first)]]
    set l [send -- $i [list set textdragdrop(last)]]
    set s [send -- $i [list set textdragdrop(source)]]
    if {"$s" != "$w"} {
	send -- $i [list $s delete $f $l]
	$w insert @$x,$y $d sel
    } elseif [$w compare @$x,$y < $f] {
	$w delete $f $l
	$w insert @$x,$y $d sel
    } else {
	$w insert @$x,$y $d sel
	$w delete $f $l
    }
    set textdragdrop(data) {}
    set textdragdrop(first) {}
    set textdragdrop(last) {}
    set textdragdrop(source) {}
}
proc text-serve-string {w t} {
    global textdragdrop
    return $textdragdrop(data)
}
proc text-serve-copymove {w t} {
    return {}
}
proc dragdrop-enable-text {w} {
    if ![llength [dragdrop source $w datacmd STRING]] {
	dragdrop source $w datacmd STRING text-serve-string
    }
    dragdrop source $w datacmd TEXT-INTERNAL-COPY text-serve-copymove
    dragdrop source $w datacmd TEXT-INTERNAL-MOVE text-serve-copymove

    set d [dragdrop destination $w dragcmd]
    if [llength $d] {
	global textdragdrop
	set textdragdrop(can-drop) $d
    }
    dragdrop destination $w dragcmd text-can-drop

    dragdrop destination $w dropcmd TEXT-INTERNAL-MOVE text-drop-move
    dragdrop destination $w dropcmd TEXT-INTERNAL-COPY text-drop-copy
    if ![llength [dragdrop destination $w dropcmd STRING]] {
	dragdrop destination $w dropcmd STRING text-drop-string
    }

    bindtags $w [concat [bindtags $w] dragdrop3]
}
