#ifndef DRAGDROP_INT_H
#define DRAGDROP_INT_H

#include <tk.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>

extern int printf();

/*** ----------------------------------------------------------------------
 * Things that may change quite a lot...
 */

#define DRAGDROP "dragdrop" /* Package prefix */
#define INIT Dragdrop_Init /* Initialisation routine */
#define LIBDIR DRAGDROP_LIBRARY /* Tcl-source directory */
#define DRAGDROPLIBVAR "DRAGDROP_LIBRARY"
/*#define MONOCHROME*/ /* Define for monochrome default dragging cursors */

/* What version is this really? */
#include "patchlevel.h"

/*** ----------------------------------------------------------------------
 * Assorted strings - you probably don't need to change these...
 */

/* Main command name */
#define MAINCMD DRAGDROP

/* Variables */
#define MAIN DRAGDROP
#define DVERSN DRAGDROP"_version"
#define DPATCH DRAGDROP"_patchLevel"
#define DLIBRY DRAGDROP"_library"

/*** ----------------------------------------------------------------------
 * Various definitions
 */

#define EOS (char *) NULL
#define ALL -1
#define NODATA (ClientData) NULL

#define FALSE 0
#define TRUE 1
#define STRING(s) #s

#define GETVAL(s)   Tcl_GetVar2(interp, MAIN, #s, TCL_GLOBAL_ONLY)
#define SETVAL(s,v) Tcl_SetVar2(interp, MAIN, #s, (v), TCL_GLOBAL_ONLY)

/* ElEval does the right thing - see dragdrop.c for why! :^) */
#define SETCURSOR(w,s)							\
	ElEval(interp, w, "configure", "-cursor", GETVAL(s), EOS)

#define V(ds) Tcl_DStringValue(ds)
#define NMT(s) ((s) && (s)[0])

#define NUMSTRSIZE 22 /* Big enough for even 64-bit integers! */
/* The above is needed since I want to perform calculations in C,
 * and must then change them back into strings <sigh>
 */

/*** ----------------------------------------------------------------------
 * Structure definitions (for tables)
 */
typedef struct {
  char *notify;
  Tcl_HashTable dataserver;
} Dragdrop_server_table;

typedef struct {
  char *draghandler;
  int typec, typecmax;
  char **typev;
  Tcl_HashTable drophandler;
} Dragdrop_client_table;

typedef struct {
  Tcl_HashTable server, client;
  Tk_Window main; /* Save searching */
} Dragdrop_data;

#endif
